// solution of task H(arvesting potatoes) written by Monika
// the solution solves both easy and hard data set

#include<cstdio>
#include<vector>
#include<iostream>
using namespace std;

vector<vector<int> > S; // the harvesting schedule

void fillrows(int loR, int hiR, int loC, int hiC, int D, int &N) {
    if (hiR - loR == 0 || hiC - loC == 0) return;
    for(int r=loR;r<hiR;++r) 
        for(int c=loC;c<hiC;c+=D) {
            for(int d=0;d<D;++d) if (c+d < hiC) S[r][c+d] = N;
            ++N;
        }
}

void fillcolumns(int loR, int hiR, int loC, int hiC, int D, int &N) {
    if (hiR - loR == 0 || hiC - loC == 0) return;
    for(int c=loC;c<hiC;++c)
        for(int r=loR;r<hiR;r+=D) {
            for(int d=0;d<D;++d) if (r+d < hiR) S[r+d][c] = N;
            ++N;
        }
}

void pattern(int loR, int hiR, int loC, int hiC, int D, int &N) {
    int r = (hiR-loR), c = (hiC-loC);
    int x = c % D, y = r % D, v = x + (x*y+D-1)/D;
    for(int c=0;c<v;++c) {
        int from = (c*r)/v;
        for(int d=0;d<D;++d) S[(from+d)%r + loR][c] = N;
        ++N;
    }
    for(int r=loR;r<hiR;++r) {
        for(int c=loC;c<hiC;++c) if (S[r][c] == 0) S[r][c] = N;
        ++N;
    }
}

int main(void) {
    int R,C,D,T;
    cin >> T;
    for(int t=0;t<T;++t) {
        cin >> R >> C >> D;
        S.clear();
        S.resize(R,vector<int>(C,0));
        int N = 1;
        long long Z = min(R % D, C % D);
        if (R >= D) Z+= C * (R / D); 
        if (C >= D) Z+= (R % D) * (C / D); 
        if (R < D || C < D || (R*C+D-1)/D >= Z) {  // covering with strips
            if (R >= D) { fillcolumns(R%D, R, 0,   C, D, N); R = R % D; }
            if (C >= D) { fillrows   (0,   R, C%D, C, D, N); C = C % D; }
            if (R % D < C % D) fillrows(0, R, 0, C, D, N); else fillcolumns(0, R, 0, C, D, N);
        } else { // covering with the special pattern
            if (R >= 2*D) { fillcolumns(R%D+D, R, 0,     C, D, N); R = R%D + D; }
            if (C >= 2*D) { fillrows   (0,     R, C%D+D, C, D, N); C = C%D + D; }
            pattern(0, R, 0, C, D, N);
        }
        for (auto row:S) { for (auto x:row) cout << x << " "; cout << endl; }
    }
}
